﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data.Objects.DataClasses;
using System.Data;
using System.Data.Linq;
using System.Reflection;
using System.Data.SqlClient;
using System.Collections;
using System.Diagnostics;
using System.IO;

namespace QuickStock_Importer
{
    public class BL
    {


        public static void WriteDebug(object s) 
        {
            try 
            {
                StreamWriter writer = new StreamWriter("QuickStock_Importer.log", true);
                writer.WriteLine("DEBUG: " + s);
                writer.Close();
            }
            catch { }
        }

        public static void WriteError(object s)
        {
            try
            {
                StreamWriter writer = new StreamWriter("QuickStock_Importer.log", true);
                writer.WriteLine("");
                writer.WriteLine("ERROR: " + s);
                writer.WriteLine("");
                writer.Close();
            }
            catch { }
        }



        public static bool ARTICOLO_Update(QuickStockEntities quickStockDB, 
                                           string codice,
                                           string descrizione,
                                           int pezzi,
                                           double peso,
                                           double prezzo,
                                           int id_Produttore,
                                           string nomeClasse,
                                           string nomeTipo,
                                           string nomeCategoria,
                                           int original_id_Produttore,
                                           string original_nomeClasse,
                                           string original_nomeTipo,
                                           string original_nomeCategoria)
        {
            try
            {
                    ARTICOLO articolo = (from a in quickStockDB.ARTICOLO
                                         where (a.CODICE_ARTICOLO == codice)
                                         select a).First();

                    articolo.DESCRIZIONE_ARTICOLO = descrizione;
                    articolo.PEZZI_PER_SCATOLA_ARTICOLO = pezzi;
                    articolo.PESO_ARTICOLO = peso;
                    articolo.PREZZO_ACQUISTO_ARTICOLO = prezzo;

                    articolo.PRODUTTORE = GetProduttoreByID(quickStockDB, id_Produttore);
                    articolo.TIPO_ARTICOLO = GetTipoArticoloByNome(quickStockDB, nomeTipo);
                    articolo.CLASSE_ARTICOLO = GetClasseArticoloByNome(quickStockDB, nomeClasse);
                    articolo.CATEGORIA_ARTICOLO = GetCategoriaArticoloByNome(quickStockDB, nomeCategoria);


                    // RIMUOVO LE VECCHIE RELAZIONI
                    PRODUTTORE original_produttore = GetProduttoreByID(quickStockDB, original_id_Produttore);
                    original_produttore.ARTICOLO.Remove(articolo);

                    TIPO_ARTICOLO original_tipo = GetTipoArticoloByNome(quickStockDB, original_nomeTipo);
                    original_tipo.ARTICOLO.Remove(articolo);

                    CLASSE_ARTICOLO original_classe = GetClasseArticoloByNome(quickStockDB, original_nomeClasse);
                    original_classe.ARTICOLO.Remove(articolo);

                    CATEGORIA_ARTICOLO original_categoria = GetCategoriaArticoloByNome(quickStockDB, original_nomeCategoria);
                    original_categoria.ARTICOLO.Remove(articolo);

                    
                    // relazioni
                    PRODUTTORE produttore = GetProduttoreByID(quickStockDB, id_Produttore);
                    produttore.ARTICOLO.Add(articolo);

                    TIPO_ARTICOLO tipo = GetTipoArticoloByNome(quickStockDB, nomeTipo);
                    tipo.ARTICOLO.Add(articolo);

                    CLASSE_ARTICOLO classe = GetClasseArticoloByNome(quickStockDB, nomeClasse);
                    classe.ARTICOLO.Add(articolo);

                    CATEGORIA_ARTICOLO categoria = GetCategoriaArticoloByNome(quickStockDB, nomeCategoria);
                    categoria.ARTICOLO.Add(articolo);

                    quickStockDB.ApplyPropertyChanges("ARTICOLO", articolo);
                    quickStockDB.SaveChanges();

                    return true;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        public static bool ARTICOLO_Insert(QuickStockEntities quickStockDB, 
                                           string codice,
                                           string descrizione,
                                           int id_Produttore,
                                           string nomeClasse,
                                           string nomeTipo,
                                           string nomeCategoria,
                                           int pezzi,
                                           double peso,
                                           double prezzo)
        {
            try
            {
                    ARTICOLO articolo = new ARTICOLO();

                    articolo.CODICE_ARTICOLO = codice;
                    articolo.DESCRIZIONE_ARTICOLO = descrizione;
                    articolo.PEZZI_PER_SCATOLA_ARTICOLO = pezzi;
                    articolo.PESO_ARTICOLO = peso;
                    articolo.PREZZO_ACQUISTO_ARTICOLO = prezzo;

                    articolo.PRODUTTORE = GetProduttoreByID(quickStockDB, id_Produttore);
                    articolo.TIPO_ARTICOLO = GetTipoArticoloByNome(quickStockDB, nomeTipo);
                    articolo.CLASSE_ARTICOLO = GetClasseArticoloByNome(quickStockDB, nomeClasse);
                    articolo.CATEGORIA_ARTICOLO = GetCategoriaArticoloByNome(quickStockDB, nomeCategoria);

                    // relazioni
                    PRODUTTORE produttore = GetProduttoreByID(quickStockDB, id_Produttore);
                    produttore.ARTICOLO.Add(articolo);

                    TIPO_ARTICOLO tipo = GetTipoArticoloByNome(quickStockDB, nomeTipo);
                    tipo.ARTICOLO.Add(articolo);

                    CLASSE_ARTICOLO classe = GetClasseArticoloByNome(quickStockDB, nomeClasse);
                    classe.ARTICOLO.Add(articolo);

                    CATEGORIA_ARTICOLO categoria = GetCategoriaArticoloByNome(quickStockDB, nomeCategoria);
                    categoria.ARTICOLO.Add(articolo);

                    quickStockDB.AddObject("ARTICOLO", articolo);

                    quickStockDB.SaveChanges();

                    return true;
            }
            catch (Exception ex)
            {
                string err = ex.Message;
            }
            return false;
        }



        public static bool CATEGORIA_Insert(QuickStockEntities quickStockDB, string NomeCategoria)
        {
            try
            {
                CATEGORIA_ARTICOLO categoria = new CATEGORIA_ARTICOLO();

                categoria.NOME_CATEGORIA_ARTICOLO = NomeCategoria;

                quickStockDB.AddObject("CATEGORIA_ARTICOLO", categoria);

                quickStockDB.SaveChanges();

                return true;
            }
            catch{}
            return false;
        }



        public static CATEGORIA_ARTICOLO GetCategoriaArticoloByNome(QuickStockEntities quickStockDB, string nomeCategoria)
        {
            CATEGORIA_ARTICOLO categoriaArticolo = null;
            try
            {
                    categoriaArticolo = (from ca in quickStockDB.CATEGORIA_ARTICOLO
                                         where ca.NOME_CATEGORIA_ARTICOLO == nomeCategoria
                                      select ca).First();

            }
            catch { }
            return categoriaArticolo;
        }        
        
        
        public static TIPO_ARTICOLO GetTipoArticoloByNome(QuickStockEntities quickStockDB, string nomeTipo)
        {
            TIPO_ARTICOLO tipoArticolo = null;
            try
            {
                    tipoArticolo = (from t in quickStockDB.TIPO_ARTICOLO
                                    where t.NOME_TIPO_ARTICOLO == nomeTipo
                                      select t).First();

            }
            catch { }
            return tipoArticolo;
        }


        public static bool TIPO_ARTICOLO_Insert(QuickStockEntities quickStockDB, string NomeTipo)
        {
            try
            {
                    TIPO_ARTICOLO tipo = new TIPO_ARTICOLO();

                    tipo.NOME_TIPO_ARTICOLO = NomeTipo;

                    quickStockDB.AddObject("TIPO_ARTICOLO", tipo);

                    quickStockDB.SaveChanges();

                    return true;
            }
            catch { }
            return false;
        }


        public static CLASSE_ARTICOLO GetClasseArticoloByNome(QuickStockEntities quickStockDB, string nomeClasse)
        {
            CLASSE_ARTICOLO classeArticolo = null;
            try
            {
                    classeArticolo = (from ca in quickStockDB.CLASSE_ARTICOLO
                                      where ca.NOME_CLASSE_ARTICOLO == nomeClasse
                                select ca).First();

            }
            catch (Exception ex) { string s = ex.Message; }
            return classeArticolo;
        }

        public static bool CLASSE_ARTICOLO_Insert(QuickStockEntities quickStockDB, string NomeClasse)
        {
            try
            {
                    CLASSE_ARTICOLO classe = new CLASSE_ARTICOLO();

                    classe.NOME_CLASSE_ARTICOLO = NomeClasse;

                    quickStockDB.AddObject("CLASSE_ARTICOLO", classe);

                    quickStockDB.SaveChanges();

                    return true;
            }
            catch { }
            return false;
        }


        public static PRODUTTORE GetProduttoreByID(QuickStockEntities quickStockDB, int idProduttore) 
        {
            PRODUTTORE produttore = null;
            try 
            {
                    produttore = (from p in quickStockDB.PRODUTTORE
                                  where p.ID_PRODUTTORE == idProduttore
                                select p).First();

            }
            catch { }
            return produttore;
        }


        public static bool PRODUTTORE_Insert(QuickStockEntities quickStockDB, int id_Produttore, string NomeProduttore)
        {
            try
            {
                PRODUTTORE produttore = new PRODUTTORE();

                produttore.ID_PRODUTTORE = id_Produttore;
                produttore.NOME_PRODUTTORE = NomeProduttore;

                quickStockDB.AddObject("PRODUTTORE", produttore);

                quickStockDB.SaveChanges();

                return true;
            }
            catch { }
            return false;
        }



        public static ARTICOLO GetArticoloByCodice(QuickStockEntities quickStockDB, string codiceArticolo)
        {
            ARTICOLO articolo = null;
            try
            {
                    articolo = (from a in quickStockDB.ARTICOLO
                                where a.CODICE_ARTICOLO == codiceArticolo
                                select a).First();

            }
            catch { }
            return articolo;
        }

    }
}