﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Threading;

namespace QuickStock_Importer
{
    public partial class Form1 : Form
    {
        DirectoryInfo dirEseguibile;
        int counter;
        int processedFiles;
        int doProcessFiles;
        string files;

        public Form1()
        {
            InitializeComponent();
        }



        private void ImportaDati(object state) 
        {
            WriteState("Avvio elaborazione ...");
            // lista dei files della directory
            dirEseguibile = new System.IO.DirectoryInfo(".");

            //Array dei file nella directory
            FileInfo[] fi = dirEseguibile.GetFiles("*.txt");

            doProcessFiles = fi.Length;
            processedFiles = 0;

            WriteState("Inizializzazione di [" + doProcessFiles.ToString() + "] file in corso ...");

            files = "";
            counter = 0;

            // conteggio record
            int numRecords = 0;
            foreach (FileInfo fiTemp in fi)
            {
                int lines = File.ReadAllLines(fiTemp.FullName).Length;
                numRecords = numRecords + lines;
            }
            SetMaxProgressBar(numRecords);


            WriteState("Elaborazione di [" + doProcessFiles.ToString() + "] file in corso ...");
            //Ciclo file
            foreach (FileInfo fiTemp in fi)
            {                
                ThreadPool.QueueUserWorkItem(new WaitCallback(importFile), fiTemp.FullName);
                //importThreadFile(fiTemp.FullName);
                files += fiTemp.FullName + ", ";                
            }

            //MessageBox.Show("Importazione terminata !" + "\n" + files);

        }


        //private void importThreadFile(object state)
        //{
        //    this.Invoke(new ParameterizedThreadStart(importFile), state);
        //}





        private void esegui_button_Click(object sender, EventArgs e)
        {
            esegui_button.Enabled = false;
            aggiorna_checkBox.Enabled = false;
            ThreadPool.QueueUserWorkItem(new WaitCallback(ImportaDati));
        }

        #region ProgressBar functions
        /// <summary>
        /// Effettua un avanzamento sulla progressBar in ThreadSafe mode
        /// </summary>
        private void PerformProgressBarStep(object o)
        {
            if (progressBar.InvokeRequired)
            {
                this.Invoke(new ThreadStart(progressBar.PerformStep));
            }
            else
            {
                progressBar.PerformStep();
            }
        }
        /// <summary>
        /// Resetta il valore della ProgressBar in ThreadSafe mode
        /// </summary>
        /// <param name="maximum"></param>
        private void ResetProgressBar(object maximum)
        {
            progressBar.Style = ProgressBarStyle.Blocks;
            progressBar.Value = 0;
            progressBar.Maximum = (int)maximum;
        }
        private void ResetProgressBar()
        {
            ResetProgressBar(100);
        }

        /// <summary>
        /// Imposta un nuovo massimo alla ProgressBar
        /// </summary>
        private void SetMaxProgressBar(int max)
        {
            if (progressBar.InvokeRequired)
            {
                this.Invoke(new ParameterizedThreadStart(ResetProgressBar), max);
            }
            else
            {
                ResetProgressBar(max);
            }
        }

        private void WriteState(object s)
        {
            WriteState(s as string);
        }

        private void WriteState(string s)
        {
            if (lbState.InvokeRequired)
            {
                this.Invoke(new ParameterizedThreadStart(WriteState), s);
            }
            else
            {
                lbState.Text = s;
            }
        }


        private void WriteCounter(object s)
        {
            WriteCounter(s as string);
        }

        private void WriteCounter(string s)
        {
            if (count_label.InvokeRequired)
            {
                this.Invoke(new ParameterizedThreadStart(WriteCounter), s);
            }
            else
            {
                count_label.Text = s;
            }
        }

        
        
        private void WriteStateCodice(object s)
        {
            WriteStateCodice(s as string);
        }

        private void WriteStateCodice(string s)
        {
            if (codice_label.InvokeRequired)
            {
                this.Invoke(new ParameterizedThreadStart(WriteStateCodice), s);
            }
            else
            {
                codice_label.Text = s;
            }
        }

        private void SetProgressBarWait()
        {
            if (progressBar.InvokeRequired)
            {
                this.Invoke(new ThreadStart(SetProgressBarWait));
            }
            else
            {
                progressBar.Style = ProgressBarStyle.Marquee;
            }
        }
        #endregion
        
        
        private void importFile(object fileName) 
        {
            StreamReader fileReader = new StreamReader(fileName.ToString());

            while (fileReader.Peek() >= 0) 
            {
                string line = fileReader.ReadLine();

                string codice       = line.Substring(0, 21).Trim();
                string descrizione  = line.Substring(21, 30).Trim();
                string produttore   = line.Substring(51, 9).Trim();
                string classe       = line.Substring(60, 7).Trim();
                string tipo         = line.Substring(67, 10).Trim();
                string categoria    = line.Substring(77, 10).Trim();
                string s_pezzi      = line.Substring(87, 42).Trim();
                string s_peso       = line.Substring(129, 17).Trim();
                string s_prezzo     = line.Substring(146, 12).Trim();

                try{
                    WriteCounter((counter++).ToString());

                    int pezzi = int.Parse(float.Parse(s_pezzi.Replace(".", ",")).ToString());
                    double peso = Math.Round(double.Parse(s_peso.Replace(".", ",")), 2);
                    double prezzo = Math.Round(double.Parse(s_prezzo.Replace(".", ",")), 2);

                    using (QuickStockEntities quickStockDB = new QuickStockEntities()) 
                    {
                        // verifica produttore
                        int id_Produttore = int.Parse(produttore);
                        PRODUTTORE oProduttore = BL.GetProduttoreByID(quickStockDB, id_Produttore);
                        if (oProduttore == null) BL.PRODUTTORE_Insert(quickStockDB, id_Produttore, "Produttore " + id_Produttore.ToString());

                        codice = codice + " - " + oProduttore.NOME_PRODUTTORE;
                        WriteStateCodice(codice);

                        // verifica classe
                        CLASSE_ARTICOLO oClasse = BL.GetClasseArticoloByNome(quickStockDB, classe);
                        if (oClasse == null) BL.CLASSE_ARTICOLO_Insert(quickStockDB, classe);

                        // verifica tipo
                        TIPO_ARTICOLO oTipo = BL.GetTipoArticoloByNome(quickStockDB, tipo);
                        if (oTipo == null) BL.TIPO_ARTICOLO_Insert(quickStockDB, classe);

                        // verifica categoria
                        CATEGORIA_ARTICOLO oCategoria = BL.GetCategoriaArticoloByNome(quickStockDB, categoria);
                        if (oCategoria == null) BL.CATEGORIA_Insert(quickStockDB, categoria);

                        // verifica articolo
                        ARTICOLO old_articolo = BL.GetArticoloByCodice(quickStockDB, codice);
                        if (old_articolo == null)
                        {
                            BL.ARTICOLO_Insert(quickStockDB, codice, descrizione, id_Produttore, classe, tipo, categoria, pezzi, peso, prezzo);
                        }
                        else 
                        {
                            if (aggiorna_checkBox.Checked)
                            {
                                BL.ARTICOLO_Update(quickStockDB, codice, descrizione, pezzi, peso, prezzo, id_Produttore, classe, tipo, categoria, oProduttore.ID_PRODUTTORE, oClasse.NOME_CLASSE_ARTICOLO, oTipo.NOME_TIPO_ARTICOLO, oCategoria.NOME_CATEGORIA_ARTICOLO);
                            }
                        }
                    
                    }
                    

                }catch{}

                PerformProgressBarStep(null);
            }

            processedFiles++;

            if (processedFiles == doProcessFiles) 
            {
                WriteState("Elaborazione file [ "+ files+" ] terminata !");
            }
        }

        private void button_Click(object sender, EventArgs e)
        {
            Close();
        }

    }
}
